local _
local GVF
if select(4, GetBuildInfo()) == 30200 then
	GVF = _G["GVF"]
else
	_, GVF = ...
end

GVF.filters["Equip Location Filter"] = {}
local filter = GVF.filters["Equip Location Filter"]

filter.equipLoc ={}
filter.equipLoc_filtered ={}
filter.equipLocChecked = false

local function NumEntries(t)
	if t then
		local count = 0
		for k in pairs(t) do
			count = count + 1
		end
		return count
	else
		return 0
	end
end

function filter:AddItem(link)
	local _, _, _, _, _, _, _, _, itemEquipLoc = GetItemInfo(link)
	if _G[itemEquipLoc] then
		self.equipLoc[itemEquipLoc] = true
	end
end

function filter:ClearAll()
	wipe(self.equipLoc)
	filter:ResetFilter()
end

function filter:isFilterd(link)
	local _, _, _, _, _, _, _, _, itemEquipLoc = GetItemInfo(link)
	return self.equipLoc_filtered[itemEquipLoc]
end

function filter:ResetFilter()
	wipe(self.equipLoc_filtered)
end

local info, itemtypesorted, itemtypesortedL = {}, {}, {}
function filter:GetDropdown(level)
	wipe(info)
	wipe(itemtypesorted)
	info.keepShownOnClick = 1
    if level == 1 then
	
		info.text = ITEMSLOTTEXT
		info.value = ITEMSLOTTEXT
		info.hasArrow = true
		info.func = function()
			local b = not self.equipLocChecked
			self.equipLocChecked = b
			for el in pairs(self.equipLoc) do
				self.equipLoc_filtered[el] = b
			end
			ToggleDropDownMenu(1, nil, GVF.FilterMenu, GVF.FilterButton, 0, 0)
			ToggleDropDownMenu(1, nil, GVF.FilterMenu, GVF.FilterButton, 0, 0)
			GVF:UpdateMerchant()
		end
		UIDropDownMenu_AddButton(info, level)
		
	elseif level == 2 and ITEMSLOTTEXT == UIDROPDOWNMENU_MENU_VALUE then
		for l in pairs(self.equipLoc) do
			local L = _G[l]
			if L then
				itemtypesorted[#itemtypesorted+1] = L
				itemtypesortedL[L] = l
			end
		end
		table.sort(itemtypesorted)

		for i = 1, #itemtypesorted do
			info.text = itemtypesorted[i]
			info.arg1 = itemtypesortedL[itemtypesorted[i]]
			info.checked = not self.equipLoc_filtered[itemtypesortedL[itemtypesorted[i]]]
			info.func = function(button, arg1)
				self.equipLoc_filtered[arg1] = not self.equipLoc_filtered[arg1]
				GVF:UpdateMerchant()
			end
			UIDropDownMenu_AddButton(info, level)
		end
	end
end