
--[[ list of all functions that are relevent
BuyMerchantItem(index[, qty]) -- no return
honorPoints, arenaPoints, itemCount = GetMerchantItemCostInfo(index);
itemTexture, itemValue, itemLink = GetMerchantItemCostItem(index, itemIndex) -- itemIndex <= itemCount from GetMerchantItemCostInfo
name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(index)
link = GetMerchantItemLink(index);
maxStack = GetMerchantItemMaxStack(index)
numItems = GetMerchantNumItems();
PickupMerchantItem(index) -- no return
ShowMerchantSellCursor(index) -- no return
GameTooltip:SetMerchantItem(merchantIndex)
]]

-- Temporary check until 3.3 goes live. -Torhal
local _
local GVF

if select(4, GetBuildInfo()) == 30200 then
	GVF = {}
else
	_, GVF = ...
end

_G["GVF"] = GVF

GVF.filters = {}
GVF.indexLookup = {}
GVF.maxIndex = 0

GVF.frame = CreateFrame('frame')
GVF.frame:SetScript("OnEvent", function()
	for k, filter in pairs(GVF.filters) do
		filter:ClearAll()
	end
	CloseDropDownMenus()
end)
GVF.frame:RegisterEvent("MERCHANT_CLOSED")

-- Let the mad hooking begin
-- we replace all the merchant functions and reroute them through our own
-- this enables us to modify any an all merchant addon out there :)
local GetMerchantNumItems_old = GetMerchantNumItems
local GetMerchantItemLink_old = GetMerchantItemLink

local function GenerateIndexLookup()
	wipe(GVF.indexLookup)
	GVF.indexLookup[0] = 0
	GVF.maxIndex = 0
	local filtered
	for i=1, GetMerchantNumItems_old() do
		local link = GetMerchantItemLink_old(i)
		if link then
			filtered = nil
			for k, filter in pairs(GVF.filters) do
				filter:AddItem(link)
				if filter:isFilterd(link) then
					filtered = true
				end
			end
			if not filtered then
				GVF.maxIndex = GVF.maxIndex + 1
				GVF.indexLookup[GVF.maxIndex] = i
			end
		else
			GVF.maxIndex = GVF.maxIndex + 1
			GVF.indexLookup[GVF.maxIndex] = i
		end
	end
end

function GetMerchantNumItems()
	GenerateIndexLookup()
	return GVF.maxIndex
end

function GetMerchantItemLink(index)
	return GetMerchantItemLink_old(GVF.indexLookup[index])
end

local BuyMerchantItem_old = BuyMerchantItem
function BuyMerchantItem(index, qty)
	return BuyMerchantItem_old(GVF.indexLookup[index], qty)
end

local GetMerchantItemCostInfo_old = GetMerchantItemCostInfo
function GetMerchantItemCostInfo(index, qty)
	return GetMerchantItemCostInfo_old(GVF.indexLookup[index], qty)
end

local GetMerchantItemCostItem_old = GetMerchantItemCostItem
function GetMerchantItemCostItem(index, itemIndex)
	return GetMerchantItemCostItem_old(GVF.indexLookup[index], itemIndex)
end

local GetMerchantItemInfo_old = GetMerchantItemInfo
function GetMerchantItemInfo(index)
	return GetMerchantItemInfo_old(GVF.indexLookup[index])
end

local GetMerchantItemMaxStack_old = GetMerchantItemMaxStack
function GetMerchantItemMaxStack(index)
	return GetMerchantItemMaxStack_old(GVF.indexLookup[index])
end

local PickupMerchantItem_old = PickupMerchantItem
function PickupMerchantItem(index)
	return PickupMerchantItem_old(GVF.indexLookup[index])
end

local ShowMerchantSellCursor_old = ShowMerchantSellCursor
function ShowMerchantSellCursor(index)
	return ShowMerchantSellCursor_old(GVF.indexLookup[index])
end

local GameTooltip_SetMerchantItem_old = GameTooltip.SetMerchantItem
function GameTooltip:SetMerchantItem(index)
	return GameTooltip_SetMerchantItem_old(self, GVF.indexLookup[index])
end

-- and we are done hooking

GVF.FilterMenu = CreateFrame("Frame", "GVF_FilterMenu", GVF.frame)
GVF.FilterMenu.onHide = function(...)
	MenuParent = nil
	MenuItem = nil
	MenuEquipSlot = nil
end
GVF.FilterMenu.HideMenu = function()
    if UIDROPDOWNMENU_OPEN_MENU == GVF.FilterMenu then
        CloseDropDownMenus()
    end
end

--MERCHANT_UPDATE
function GVF:UpdateMerchant()
	local frame = EnumerateFrames()
	while frame do
		if frame:IsEventRegistered("MERCHANT_UPDATE") then
			local func = frame:GetScript("OnEvent")
			func(frame, "MERCHANT_UPDATE")
		end
		frame = EnumerateFrames(frame)
	end
	GenerateIndexLookup()
end

GVF.FilterButton = CreateFrame('Button',nil,MerchantFrame)
	GVF.FilterButton:SetWidth(30)
	GVF.FilterButton:SetHeight(30)
	GVF.FilterButton:SetPoint("TOPRIGHT", MerchantFrame, "TOPRIGHT",-55,-9)
	GVF.FilterButton:SetNormalTexture([[Interface\ChatFrame\UI-ChatIcon-ScrollDown-Up]])
	GVF.FilterButton:SetPushedTexture([[Interface\ChatFrame\UI-ChatIcon-ScrollDown-Down]])
	GVF.FilterButton:SetDisabledTexture([[Interface\ChatFrame\UI-ChatIcon-ScrollDown-Disabled]])
	GVF.FilterButton:SetHighlightTexture([[Interface\Buttons\UI-Common-MouseHilight]])
	GVF.FilterButton:SetScript('OnClick', function(self)
		ToggleDropDownMenu(1, nil, GVF.FilterMenu, self, 0, 0)
	end)

local info, sortedFilters = {}, {}
GVF.FilterMenu.initialize = function(self, level)
	if not level then return end
    if level == 1 then
		wipe(info)
		wipe(sortedFilters)
		for k in pairs(GVF.filters) do
			sortedFilters[#sortedFilters+1] = k
		end
		table.sort(sortedFilters)

		for i = 1, #sortedFilters do
			-- Create the title of the menu
			info.isTitle = 1
			info.text = sortedFilters[i]
			info.notCheckable = 1
			UIDropDownMenu_AddButton(info, level)
			
			GVF.filters[sortedFilters[i]]:GetDropdown(level)
		end
		info.isTitle = nil
		info.disabled = nil
        info.notCheckable = 1
		
		info.text = RED_FONT_COLOR_CODE..RESET
		info.keepShownOnClick = 1
		info.func = function()
			for k, filter in pairs(GVF.filters) do
				filter:ResetFilter()
			end
			ToggleDropDownMenu(1, nil, GVF.FilterMenu, GVF.FilterButton, 0, 0)
			ToggleDropDownMenu(1, nil, GVF.FilterMenu, GVF.FilterButton, 0, 0)
			GVF:UpdateMerchant()
		end
		UIDropDownMenu_AddButton(info, level)
		
		info.text = CLOSE
		info.func = self.HideMenu
		UIDropDownMenu_AddButton(info, level)

	elseif level == 2 then
		for k, filter in pairs(GVF.filters) do
			filter:GetDropdown(level)
		end
	end
end
